Index: /pjproject/trunk/pjlib/include/pj/assert.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/assert.h	(revision 105)
+++ /pjproject/trunk/pjlib/include/pj/assert.h	(revision 106)
@@ -68,4 +68,24 @@
 #endif
 
+/**
+ * @hideinitializer
+ * If #PJ_ENABLE_EXTRA_CHECK is declared and non-zero, then 
+ * #PJ_ASSERT_ON_FAIL macro will evaluate the expression in @a expr during
+ * run-time. If the expression yields false, assertion will be triggered
+ * and @a exec_on_fail will be executed.
+ *
+ * If #PJ_ENABLE_EXTRA_CHECK is not declared or is zero, then no run-time
+ * checking will be performed. The macro simply evaluates to pj_assert(expr).
+ */
+#if defined(PJ_ENABLE_EXTRA_CHECK) && PJ_ENABLE_EXTRA_CHECK != 0
+#   define PJ_ASSERT_ON_FAIL(expr,exec_on_fail)    \
+	    do { \
+		pj_assert(expr); \
+		if (!(expr)) exec_on_fail; \
+	    } while (0)
+#else
+#   define PJ_ASSERT_ON_FAIL(expr,exec_on_fail)    pj_assert(expr)
+#endif
+
 /** @} */
 
Index: /pjproject/trunk/pjlib/include/pj/os.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/os.h	(revision 105)
+++ /pjproject/trunk/pjlib/include/pj/os.h	(revision 106)
@@ -505,4 +505,73 @@
  * @}
  */
+
+///////////////////////////////////////////////////////////////////////////////
+/**
+ * @defgroup PJ_RW_MUTEX Reader/Writer Mutex
+ * @ingroup PJ_OS
+ * @{
+ * Reader/writer mutex is a classic synchronization object where multiple
+ * readers can acquire the mutex, but only a single writer can acquire the 
+ * mutex.
+ */
+typedef struct pj_rwmutex_t pj_rwmutex_t;
+
+/**
+ * Create reader/writer mutex.
+ *
+ * @param pool	    Pool to allocate memory for the mutex.
+ * @param name	    Name to be assigned to the mutex.
+ * @param mutex	    Pointer to receive the newly created mutex.
+ *
+ * @return	    PJ_SUCCESS on success, or the error code.
+ */
+PJ_DECL(pj_status_t) pj_rwmutex_create(pj_pool_t *pool, const char *name,
+				       pj_rwmutex_t **mutex);
+
+/**
+ * Lock the mutex for reading.
+ *
+ * @param mutex	    The mutex.
+ * @return	    PJ_SUCCESS on success, or the error code.
+ */
+PJ_DECL(pj_status_t) pj_rwmutex_lock_read(pj_rwmutex_t *mutex);
+
+/**
+ * Lock the mutex for writing.
+ *
+ * @param mutex	    The mutex.
+ * @return	    PJ_SUCCESS on success, or the error code.
+ */
+PJ_DECL(pj_status_t) pj_rwmutex_lock_write(pj_rwmutex_t *mutex);
+
+/**
+ * Release read lock.
+ *
+ * @param mutex	    The mutex.
+ * @return	    PJ_SUCCESS on success, or the error code.
+ */
+PJ_DECL(pj_status_t) pj_rwmutex_unlock_read(pj_rwmutex_t *mutex);
+
+/**
+ * Release write lock.
+ *
+ * @param mutex	    The mutex.
+ * @return	    PJ_SUCCESS on success, or the error code.
+ */
+PJ_DECL(pj_status_t) pj_rwmutex_unlock_write(pj_rwmutex_t *mutex);
+
+/**
+ * Destroy reader/writer mutex.
+ *
+ * @param mutex	    The mutex.
+ * @return	    PJ_SUCCESS on success, or the error code.
+ */
+PJ_DECL(pj_status_t) pj_rwmutex_destroy(pj_rwmutex_t *mutex);
+
+
+/**
+ * @}
+ */
+
 
 ///////////////////////////////////////////////////////////////////////////////
Index: /pjproject/trunk/pjlib/include/pj/sock.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/sock.h	(revision 105)
+++ /pjproject/trunk/pjlib/include/pj/sock.h	(revision 106)
@@ -177,5 +177,5 @@
  * This structure describes Internet socket address.
  */
-typedef struct pj_sockaddr_in
+struct pj_sockaddr_in
 {
     pj_uint16_t	sin_family;	/**< Address family.		    */
@@ -183,5 +183,5 @@
     pj_in_addr	sin_addr;	/**< IP address.		    */
     char	sin_zero[8];	/**< Padding.			    */
-} pj_sockaddr_in;
+};
 
 
Index: /pjproject/trunk/pjlib/include/pj/types.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/types.h	(revision 105)
+++ /pjproject/trunk/pjlib/include/pj/types.h	(revision 106)
@@ -218,4 +218,7 @@
 /** Generic socket address. */
 typedef void pj_sockaddr_t;
+
+/** Forward declaration. */
+typedef struct pj_sockaddr_in pj_sockaddr_in;
 
 /** Color type. */
Index: /pjproject/trunk/pjlib/src/pj/os_core_win32.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 105)
+++ /pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 106)
@@ -860,4 +860,121 @@
 
 ///////////////////////////////////////////////////////////////////////////////
+
+struct pj_rwmutex_t
+{
+    pj_mutex_t *read_lock, *write_lock;
+    int reader_count;
+};
+
+/*
+ * Create reader/writer mutex.
+ *
+ */
+PJ_DEF(pj_status_t) pj_rwmutex_create(pj_pool_t *pool, const char *name,
+				      pj_rwmutex_t **p_mutex)
+{
+    pj_status_t status;
+    pj_rwmutex_t *rwmutex;
+
+    PJ_ASSERT_RETURN(pool && p_mutex, PJ_EINVAL);
+
+    *p_mutex = NULL;
+    rwmutex = pj_pool_alloc(pool, sizeof(struct pj_rwmutex_t));
+
+    status = pj_mutex_create_simple(pool, name, &rwmutex ->read_lock);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    status = pj_mutex_create_recursive(pool, name, &rwmutex->write_lock);
+    if (status != PJ_SUCCESS) {
+	pj_mutex_destroy(rwmutex->read_lock);
+	return status;
+    }
+
+    rwmutex->reader_count = 0;
+    *p_mutex = rwmutex;
+    return PJ_SUCCESS;
+}
+
+/*
+ * Lock the mutex for reading.
+ *
+ */
+PJ_DEF(pj_status_t) pj_rwmutex_lock_read(pj_rwmutex_t *mutex)
+{
+    pj_status_t status;
+
+    PJ_ASSERT_RETURN(mutex, PJ_EINVAL);
+
+    status = pj_mutex_lock(mutex->read_lock);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    mutex->reader_count++;
+    if (mutex->reader_count == 1)
+	pj_mutex_lock(mutex->write_lock);
+
+    status = pj_mutex_unlock(mutex->read_lock);
+    return status;
+}
+
+/*
+ * Lock the mutex for writing.
+ *
+ */
+PJ_DEF(pj_status_t) pj_rwmutex_lock_write(pj_rwmutex_t *mutex)
+{
+    PJ_ASSERT_RETURN(mutex, PJ_EINVAL);
+    return pj_mutex_lock(mutex->write_lock);
+}
+
+/*
+ * Release read lock.
+ *
+ */
+PJ_DEF(pj_status_t) pj_rwmutex_unlock_read(pj_rwmutex_t *mutex)
+{
+    pj_status_t status;
+
+    PJ_ASSERT_RETURN(mutex, PJ_EINVAL);
+
+    status = pj_mutex_lock(mutex->read_lock);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    pj_assert(mutex->reader_count >= 1);
+
+    --mutex->reader_count;
+    if (mutex->reader_count == 0)
+	pj_mutex_unlock(mutex->write_lock);
+
+    status = pj_mutex_unlock(mutex->read_lock);
+    return status;
+}
+
+/*
+ * Release write lock.
+ *
+ */
+PJ_DEF(pj_status_t) pj_rwmutex_unlock_write(pj_rwmutex_t *mutex)
+{
+    PJ_ASSERT_RETURN(mutex, PJ_EINVAL);
+    return pj_mutex_unlock(mutex->write_lock);
+}
+
+
+/*
+ * Destroy reader/writer mutex.
+ *
+ */
+PJ_DEF(pj_status_t) pj_rwmutex_destroy(pj_rwmutex_t *mutex)
+{
+    PJ_ASSERT_RETURN(mutex, PJ_EINVAL);
+    pj_mutex_destroy(mutex->read_lock);
+    pj_mutex_destroy(mutex->write_lock);
+    return PJ_SUCCESS;
+}
+
+///////////////////////////////////////////////////////////////////////////////
 /*
  * pj_enter_critical_section()
Index: /pjproject/trunk/pjlib/src/pj/sock_bsd.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/sock_bsd.c	(revision 105)
+++ /pjproject/trunk/pjlib/src/pj/sock_bsd.c	(revision 106)
@@ -188,5 +188,5 @@
     PJ_CHECK_STACK();
 
-    PJ_ASSERT_RETURN(str_addr && str_addr->slen < PJ_MAX_HOSTNAME, 
+    PJ_ASSERT_RETURN(!str_addr || str_addr->slen < PJ_MAX_HOSTNAME, 
                      (addr->sin_addr.s_addr=PJ_INADDR_NONE, PJ_EINVAL));
 
@@ -225,6 +225,5 @@
 					 pj_uint16_t port)
 {
-    PJ_ASSERT_RETURN(addr && str_addr, 
-                     (addr->sin_addr.s_addr=PJ_INADDR_NONE, PJ_EINVAL));
+    PJ_ASSERT_RETURN(addr, (addr->sin_addr.s_addr=PJ_INADDR_NONE, PJ_EINVAL));
 
     addr->sin_family = PJ_AF_INET;
Index: /pjproject/trunk/pjsip/build/pjsip_core.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 105)
+++ /pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 106)
@@ -125,4 +125,5 @@
 
 SOURCE=..\src\pjsip\sip_transaction.c
+# PROP Exclude_From_Build 1
 # End Source File
 # Begin Source File
@@ -141,4 +142,9 @@
 
 SOURCE=..\src\pjsip\sip_util.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_util_statefull.c
+# PROP Exclude_From_Build 1
 # End Source File
 # End Group
Index: /pjproject/trunk/pjsip/build/test_pjsip.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 105)
+++ /pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 106)
@@ -102,4 +102,16 @@
 # Begin Source File
 
+SOURCE="..\src\test-pjsip\transport_test.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\test-pjsip\transport_udp_test.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\test-pjsip\txdata_test.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\test-pjsip\uri_test.c"
 # End Source File
Index: /pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 105)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_endpoint.h	(revision 106)
@@ -116,4 +116,32 @@
 					 const pj_time_val *max_timeout);
 
+
+/**
+ * Schedule timer to endpoint's timer heap. Application must poll the endpoint
+ * periodically (by calling #pjsip_endpt_handle_events) to ensure that the
+ * timer events are handled in timely manner. When the timeout for the timer
+ * has elapsed, the callback specified in the entry argument will be called.
+ * This function, like all other endpoint functions, is thread safe.
+ *
+ * @param endpt	    The endpoint.
+ * @param entry	    The timer entry.
+ * @param delay	    The relative delay of the timer.
+ * @return	    PJ_OK (zero) if successfull.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_schedule_timer( pjsip_endpoint *endpt,
+						 pj_timer_entry *entry,
+						 const pj_time_val *delay );
+
+/**
+ * Cancel the previously registered timer.
+ * This function, like all other endpoint functions, is thread safe.
+ *
+ * @param endpt	    The endpoint.
+ * @param entry	    The timer entry previously registered.
+ */
+PJ_DECL(void) pjsip_endpt_cancel_timer( pjsip_endpoint *endpt, 
+					pj_timer_entry *entry );
+
+
 /**
  * Dump endpoint status to the log. This will print the status to the log
@@ -126,4 +154,33 @@
  */
 PJ_DECL(void) pjsip_endpt_dump( pjsip_endpoint *endpt, pj_bool_t detail );
+
+
+/**
+ * Register new module to the endpoint.
+ * The endpoint will then call the load and start function in the module to 
+ * properly initialize the module, and assign a unique module ID for the 
+ * module.
+ *
+ * @param endpt		The endpoint.
+ * @param module	The module to be registered.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_register_module( pjsip_endpoint *endpt,
+						  pjsip_module *module );
+
+/**
+ * Unregister a module from the endpoint.
+ * The endpoint will then call the stop and unload function in the module to 
+ * properly shutdown the module.
+ *
+ * @param endpt		The endpoint.
+ * @param module	The module to be registered.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_unregister_module( pjsip_endpoint *endpt,
+						    pjsip_module *module );
+
 
 /**
@@ -157,30 +214,4 @@
 
 /**
- * Schedule timer to endpoint's timer heap. Application must poll the endpoint
- * periodically (by calling #pjsip_endpt_handle_events) to ensure that the
- * timer events are handled in timely manner. When the timeout for the timer
- * has elapsed, the callback specified in the entry argument will be called.
- * This function, like all other endpoint functions, is thread safe.
- *
- * @param endpt	    The endpoint.
- * @param entry	    The timer entry.
- * @param delay	    The relative delay of the timer.
- * @return	    PJ_OK (zero) if successfull.
- */
-PJ_DECL(pj_status_t) pjsip_endpt_schedule_timer( pjsip_endpoint *endpt,
-						 pj_timer_entry *entry,
-						 const pj_time_val *delay );
-
-/**
- * Cancel the previously registered timer.
- * This function, like all other endpoint functions, is thread safe.
- *
- * @param endpt	    The endpoint.
- * @param entry	    The timer entry previously registered.
- */
-PJ_DECL(void) pjsip_endpt_cancel_timer( pjsip_endpoint *endpt, 
-					pj_timer_entry *entry );
-
-/**
  * Create a new transaction. After creating the transaction, application MUST
  * initialize the transaction as either UAC or UAS (by calling
@@ -279,9 +310,10 @@
  * @see pjsip_transport_get
  */
-PJ_DECL(pj_status_t) pjsip_endpt_alloc_transport( pjsip_endpoint *endpt,
-						  pjsip_transport_type_e type,
-						  const pj_sockaddr *remote,
-						  int addr_len,
-						  pjsip_transport **p_transport);
+PJ_DECL(pj_status_t) 
+pjsip_endpt_acquire_transport( pjsip_endpoint *endpt,
+			       pjsip_transport_type_e type,
+			       const pj_sockaddr_t *remote,
+			       int addr_len,
+			       pjsip_transport **p_transport);
 
 /**
Index: /pjproject/trunk/pjsip/include/pjsip/sip_errno.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 105)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 106)
@@ -94,5 +94,5 @@
 /**
  * @hideinitializer
- * Invalid message (syntax error)
+ * General invalid message error (e.g. syntax error)
  */
 #define PJSIP_EINVALIDMSG       (PJSIP_ERRNO_START_PJSIP + 20)	/* 171020 */
@@ -114,17 +114,43 @@
 /**
  * @hideinitializer
+ * Missing Request-URI.
+ */
+#define PJSIP_EMISSINGREQURI    (PJSIP_ERRNO_START_PJSIP + 24)	/* 171024 */
+/**
+ * @hideinitializer
  * Missing required header(s).
  */
-#define PJSIP_EMISSINGHDR       (PJSIP_ERRNO_START_PJSIP + 24)	/* 171024 */
+#define PJSIP_EMISSINGHDR       (PJSIP_ERRNO_START_PJSIP + 25)	/* 171025 */
+/**
+ * @hideinitializer
+ * Missing message body.
+ */
+#define PJSIP_EMISSINGBODY	(PJSIP_ERRNO_START_PJSIP + 26)	/* 171026 */
 /**
  * @hideinitializer
  * Invalid Via header in response (sent-by, etc).
  */
-#define PJSIP_EINVALIDVIA	(PJSIP_ERRNO_START_PJSIP + 25)	/* 171025 */
+#define PJSIP_EINVALIDVIA	(PJSIP_ERRNO_START_PJSIP + 27)	/* 171027 */
 /**
  * @hideinitializer
  * Multiple Via headers in response.
  */
-#define PJSIP_EMULTIPLEVIA	(PJSIP_ERRNO_START_PJSIP + 26)	/* 171026 */
+#define PJSIP_EMULTIPLEVIA	(PJSIP_ERRNO_START_PJSIP + 28)	/* 171028 */
+/**
+ * @hideinitializer
+ * Invalid request URI.
+ */
+#define PJSIP_EINVALIDREQURI	(PJSIP_ERRNO_START_PJSIP + 29)	/* 171029 */
+/**
+ * @hideinitializer
+ * Expecting request message.
+ */
+#define PJSIP_ENOTREQUESTMSG	(PJSIP_ERRNO_START_PJSIP + 30)	/* 171030 */
+/**
+ * @hideinitializer
+ * Expecting response message.
+ */
+#define PJSIP_ENOTRESPONSEMSG	(PJSIP_ERRNO_START_PJSIP + 31)	/* 171031 */
+
 
 /************************************************************
@@ -145,5 +171,11 @@
  * Rx buffer overflow. See also PJSIP_EMSGTOOLONG.
  */
-#define PJSIP_ERXOVERFLOW         (PJSIP_ERRNO_START_PJSIP + 42)/* 171042 */
+#define PJSIP_ERXOVERFLOW       (PJSIP_ERRNO_START_PJSIP + 42)	/* 171042 */
+/**
+ * @hideinitializer
+ * This is not really an error, it just informs application that
+ * transmit data has been deleted on return of pjsip_tx_data_dec_ref().
+ */
+#define PJSIP_EBUFDESTROYED     (PJSIP_ERRNO_START_PJSIP + 43)	/* 171043 */
 
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_module.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 105)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_module.h	(revision 106)
@@ -42,4 +42,7 @@
 struct pjsip_module
 {
+    /** To allow chaining of modules in the endpoint. */
+    PJ_DECL_LIST_MEMBER(struct pjsip_module);
+
     /**
      * Module name.
@@ -48,7 +51,7 @@
 
     /**
-     * Flag to indicate the type of interfaces supported by the module.
+     * Module ID.
      */
-    pj_uint32_t flag;
+    int id;
 
     /**
@@ -57,5 +60,5 @@
      * initialized later.
      */
-    pj_uint32_t priority;
+    int priority;
 
     /**
@@ -63,5 +66,5 @@
      * the module itself.
      */
-    void *mod_data;
+    void *user_data;
 
     /**
@@ -79,20 +82,22 @@
      *
      * @param endpt	The endpoint instance.
-     * @param mod	The module.
-     * @param id	The unique module ID assigned to this module.
-     *
-     * @return		Module should return zero when initialization succeed.
+     * @return		Module should return PJ_SUCCESS to indicate success.
      */
-    pj_status_t (*init_module)(pjsip_endpoint *endpt,
-			       struct pjsip_module *mod, pj_uint32_t id);
+    pj_status_t (*load)(pjsip_endpoint *endpt);
 
     /**
      * Pointer to function to be called to start the module.
      *
-     * @param mod	The module.
-     *
      * @return		Module should return zero to indicate success.
      */
-    pj_status_t (*start_module)(struct pjsip_module *mod);
+    pj_status_t (*start)(void);
+
+    /**
+     * Pointer to function to be called to deinitialize the module before
+     * it is unloaded.
+     *
+     * @return		Module should return PJ_SUCCESS to indicate success.
+     */
+    pj_status_t (*stop)(void);
 
     /**
@@ -102,32 +107,53 @@
      * @param mod	The module.
      *
-     * @return		Module should return zero to indicate success.
+     * @return		Module should return PJ_SUCCESS to indicate success.
      */
-    pj_status_t (*deinit_module)(struct pjsip_module *mod);
+    pj_status_t (*unload)(void);
 
     /**
-     * Pointer to function to receive transaction related events.
-     * If the module doesn't wish to receive such notification, this member
-     * must be set to NULL.
+     * Called to process incoming request.
      *
-     * @param mod	The module.
-     * @param event	The transaction event.
+     * @param rdata	The incoming message.
+     *
+     * @return		Module should return PJ_TRUE if it handles the request,
+     *			or otherwise it should return PJ_FALSE to allow other
+     *			modules to handle the request.
      */
-    void (*tsx_handler)(struct pjsip_module *mod, pjsip_event *event);
+    pj_bool_t (*on_rx_request)(pjsip_rx_data *rdata);
+
+    /**
+     * Called to processed incoming response.
+     *
+     * @param rdata	The incoming message.
+     *
+     * @return		Module should return PJ_TRUE if it handles the 
+     *			response, or otherwise it should return PJ_FALSE to 
+     *			allow other modules to handle the response.
+     */
+    pj_bool_t (*on_rx_response)(pjsip_rx_data *rdata);
+
+    /**
+     * Called when this module is acting as transaction user for the specified
+     * transaction, when the transaction's state has changed.
+     *
+     * @param tsx	The transaction.
+     * @param event	The event which has caused the transaction state
+     *			to change.
+     */
+    void (*on_tsx_state)(pjsip_transaction *tsx, pjsip_event *event);
+
 };
 
 
 /**
- * Prototype of function to register static modules (eg modules that are
- * linked staticly with the application). This function must be implemented 
- * by any applications that use PJSIP library.
- *
- * @param count	    [input/output] On input, it contains the maximum number of
- *		    elements in the array. On output, the function fills with 
- *		    the number of modules to be registered.
- * @param modules   [output] array of pointer to modules to be registered.
+ * Module priority guidelines.
  */
-pj_status_t register_static_modules( pj_size_t *count,
-				     pjsip_module **modules );
+enum pjsip_module_priority
+{
+    PJSIP_MOD_PRIORITY_TSX_LAYER = 4,
+    PJSIP_MOD_PRIORITY_UA_PROXY_LAYER = 16,
+    PJSIP_MOD_PRIORITY_APPLICATION = 32,
+};
+
 
 /**
Index: /pjproject/trunk/pjsip/include/pjsip/sip_msg.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 105)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_msg.h	(revision 106)
@@ -53,25 +53,12 @@
 typedef enum pjsip_method_e
 {
-    /** INVITE method, for establishing dialogs. */
-    PJSIP_INVITE_METHOD,
-
-    /** CANCEL method, for cancelling request. */
-    PJSIP_CANCEL_METHOD,
-
-    /** ACK method, for acknowledging final response to INVITE. */
-    PJSIP_ACK_METHOD,
-
-    /** BYE method, for terminating dialog. */
-    PJSIP_BYE_METHOD,
-
-    /** REGISTER method. */
-    PJSIP_REGISTER_METHOD,
-
-    /** OPTIONS method, for querying remote capabilities. */
-    PJSIP_OPTIONS_METHOD,
-
-    /** Other method, which means that the method name itself will be stored
-        elsewhere. */
-    PJSIP_OTHER_METHOD,
+    PJSIP_INVITE_METHOD,    /**< INVITE method, for establishing dialogs.   */
+    PJSIP_CANCEL_METHOD,    /**< CANCEL method, for cancelling request.	    */
+    PJSIP_ACK_METHOD,	    /**< ACK method.				    */
+    PJSIP_BYE_METHOD,	    /**< BYE method, for terminating dialog.	    */
+    PJSIP_REGISTER_METHOD,  /**< REGISTER method.			    */
+    PJSIP_OPTIONS_METHOD,   /**< OPTIONS method.			    */
+
+    PJSIP_OTHER_METHOD,	    /**< Other method.				    */
 
 } pjsip_method_e;
@@ -92,4 +79,15 @@
 			         method string. */
 } pjsip_method;
+
+
+/*
+ * For convenience, standard method structures are defined in the library.
+ */
+extern const pjsip_method pjsip_invite_method;	    /**< INVITE structure.  */
+extern const pjsip_method pjsip_cancel_method;	    /**< CANCEL structure.  */
+extern const pjsip_method pjsip_ack_method;	    /**< ACK structure.     */
+extern const pjsip_method pjsip_bye_method;	    /**< BYE structure.     */
+extern const pjsip_method pjsip_register_method;    /**< REGISTER structure.*/
+extern const pjsip_method pjsip_options_method;	    /**< OPTIONS structure. */
 
 
@@ -639,6 +637,6 @@
  *		    type is found.
  */
-PJ_DECL(void*)  pjsip_msg_find_hdr( pjsip_msg *msg, 
-				    pjsip_hdr_e type, void *start);
+PJ_DECL(void*)  pjsip_msg_find_hdr( const pjsip_msg *msg, 
+				    pjsip_hdr_e type, const void *start);
 
 /** 
@@ -655,6 +653,7 @@
  *		    type is found.
  */
-PJ_DECL(void*)  pjsip_msg_find_hdr_by_name( pjsip_msg *msg, 
-					    const pj_str_t *name, void *start);
+PJ_DECL(void*)  pjsip_msg_find_hdr_by_name( const pjsip_msg *msg, 
+					    const pj_str_t *name, 
+					    const void *start);
 
 /** 
@@ -703,5 +702,6 @@
  *		value if the message is too large for the specified buffer.
  */
-PJ_DECL(pj_ssize_t) pjsip_msg_print(pjsip_msg *msg, char *buf, pj_size_t size);
+PJ_DECL(pj_ssize_t) pjsip_msg_print(const pjsip_msg *msg, 
+				    char *buf, pj_size_t size);
 
 /**
Index: /pjproject/trunk/pjsip/include/pjsip/sip_transport.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 105)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_transport.h	(revision 106)
@@ -368,9 +368,13 @@
 /**
  * Decrement reference counter of the transmit buffer.
- * When the transmit buffer is no longer used, it will be destroyed.
+ * When the transmit buffer is no longer used, it will be destroyed and
+ * caller is informed with PJSIP_EBUFDESTROYED return status.
  *
  * @param tdata	    The transmit buffer data.
- */
-PJ_DECL(void) pjsip_tx_data_dec_ref( pjsip_tx_data *tdata );
+ * @return	    This function will always succeeded eventhough the return
+ *		    status is non-zero. A status PJSIP_EBUFDESTROYED will be
+ *		    returned to inform that buffer is destroyed.
+ */
+PJ_DECL(pj_status_t) pjsip_tx_data_dec_ref( pjsip_tx_data *tdata );
 
 /**
@@ -378,4 +382,5 @@
  *
  * @param tdata	    The transmit buffer.
+ * @return	    Non-zero (PJ_TRUE) if buffer contains a valid message.
  */
 PJ_DECL(pj_bool_t) pjsip_tx_data_is_valid( pjsip_tx_data *tdata );
@@ -543,4 +548,6 @@
     /**
      * Create new outbound connection.
+     * Note that the factory is responsible for both creating the
+     * transport and registering it to the transport manager.
      */
     pj_status_t (*create_transport)(pjsip_tpfactory *factory,
@@ -548,4 +555,5 @@
 				    pjsip_endpoint *endpt,
 				    const pj_sockaddr *rem_addr,
+				    int addr_len,
 				    pjsip_transport **transport);
 
@@ -622,9 +630,9 @@
  * suitable transport is found, a new one will be created.
  */
-PJ_DECL(pj_status_t) pjsip_tpmgr_alloc_transport( pjsip_tpmgr *mgr,
-						  pjsip_transport_type_e type,
-						  const pj_sockaddr_t *remote,
-						  int addr_len,
-						  pjsip_transport **p_transport );
+PJ_DECL(pj_status_t) pjsip_tpmgr_acquire_transport(pjsip_tpmgr *mgr,
+						   pjsip_transport_type_e type,
+						   const pj_sockaddr_t *remote,
+						   int addr_len,
+						   pjsip_transport **tp);
 
 
Index: /pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h	(revision 105)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_transport_udp.h	(revision 106)
@@ -22,5 +22,5 @@
 #include <pjsip/sip_transport.h>
 
-PJ_DECL
+PJ_BEGIN_DECL
 
 /**
